﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.51
@EndOfDesignText@
'Static code module
Sub Process_Globals
	Private fx As JFX
	'Holds variables for resizing the form
	Type ResizeRectType(ResizeDirection As String, LastSceneX As Double, LastSceneY As Double, Listener As Object, Scale As Double, InitialWidth As Double, InitialHeight As Double)
	Private ResizeMap As Map
	Private MinWidth As Double = 10
	Private MinHeight As Double = 10
	
End Sub

Public Sub AddListeners(N As Node)
	Dim NJO As JavaObject = N
	Dim O As Object = NJO.CreateEventFromUI("javafx.event.EventHandler","HandleMouse",Null)
	NJO.RunMethod("setOnMouseMoved",Array(O))
	NJO.RunMethod("setOnMouseDragged",Array(O))
	NJO.RunMethod("setOnMouseReleased",Array(O))
	Dim ResizeRect As ResizeRectType
	ResizeRect.Initialize
	If ResizeMap.IsInitialized = False Then ResizeMap.Initialize
	ResizeRect.Listener = O
	ResizeRect.initialWidth = N.PrefWidth
	ResizeRect.initialHeight = N.PrefHeight
	ResizeRect.Scale = 1
	ResizeMap.Put(N,ResizeRect)
	
End Sub

Public Sub SetMinWidth(Width As Double)
	MinWidth = Width
End Sub

Public Sub SetMinHeight(Height As Double)
	MinWidth = Height
End Sub

Public Sub GetMinHeight As Double
	Return MinHeight
End Sub

Public Sub GetMinWidth As Double
	Return MinWidth
End Sub

Private Sub HandleMouse_Event (MethodName As String, Args() As Object)
	Dim Event As jMouseEvent
	Event.Initialize
	Event.SetObject(Args(0))

	Dim NodeWrapper1 As NodeWrapper
	NodeWrapper1.Initialize(Event.GetSource)
	
	Dim ResizeRect As ResizeRectType = ResizeMap.Get(NodeWrapper1.ASNode)
	
	Dim Offset As Int = 4
	Dim ET As String = Event.GetEventType.RunMethod("getName",Null)
	
	Select ET
		Case "MOUSE_MOVED"
			'Cursor class
			Dim Cursors As JavaObject
			Cursors.InitializeStatic("javafx.scene.Cursor")
	
			'Holds the cursor to display dependant on start position
			Dim Cursor As Object
			Cursor = fx.Cursors.DEFAULT

			'Resize parameters
			ResizeRect.ResizeDirection = ""
			ResizeRect.LastSceneX = Event.GetSceneX
			ResizeRect.LastSceneY  = Event.GetSceneY
			
			'Check if the mouse cursor is at an edge of the screen and set the resize direction
			If Event.getSceneX < NodeWrapper1.LayoutX + Offset Then
				If Event.GetSceneY < NodeWrapper1.LayoutY + Offset Then
					Cursor = Cursors.GetField("NW_RESIZE")
					ResizeRect.ResizeDirection = "NW"
				Else If Event.GetSceneY > NodeWrapper1.LayoutY + NodeWrapper1.ASNode.PrefHeight - Offset Then
					Cursor = Cursors.GetField("SW_RESIZE")
					ResizeRect.ResizeDirection = "SW"
				Else
					Cursor = Cursors.GetField("W_RESIZE")
					ResizeRect.ResizeDirection = "W"
				End If
			Else If Event.GetSceneY < NodeWrapper1.LayoutY + Offset Then
				If Event.GetSceneX > NodeWrapper1.LayoutX + NodeWrapper1.ASNode.PrefWidth - Offset Then
					Cursor = Cursors.GetField("NE_RESIZE")
					ResizeRect.ResizeDirection = "NE"
				Else
					Cursor = Cursors.GetField("N_RESIZE")
					ResizeRect.ResizeDirection = "N"
				End If
			Else If Event.GetSceneX > NodeWrapper1.LayoutX + NodeWrapper1.ASNode.PrefWidth - Offset Then
				If Event.GetSceneY > NodeWrapper1.LayoutY + NodeWrapper1.ASNode.PrefHeight - Offset Then
					Cursor = Cursors.GetField("SE_RESIZE")
					ResizeRect.ResizeDirection = "SE"
				Else
					Cursor = Cursors.GetField("E_RESIZE")
					ResizeRect.ResizeDirection = "E"
				End If
			Else If Event.GetSceneY > NodeWrapper1.LayoutY + NodeWrapper1.ASNode.PrefHeight - Offset Then
				Cursor = Cursors.GetField("S_RESIZE")
				ResizeRect.ResizeDirection = "S"
			Else
				Cursor = fx.Cursors.Move
				ResizeRect.ResizeDirection = "M"
'				If MainForm.RootPane.MouseCursor = fx.Cursors.DEFAULT Then Return
			End If
			Event.Consume
			NodeWrapper1.AsNode.MouseCursor = Cursor
			
			
		Case "MOUSE_DRAGGED"
			
			If ResizeRect.ResizeDirection = "" Then Return
			
			Dim Event As jMouseEvent
			Event.Initialize
			Event.SetObject(Args(0))
	
			Dim SceneX As Double = Event.GetSceneX
			Dim SceneY As Double = Event.GetSceneY
				
			Dim Top As Double = NodeWrapper1.LayoutY
			Dim Left As Double = NodeWrapper1.LayoutX
			Dim Width As Double = NodeWrapper1.AsNode.PrefWidth
			Dim Height As Double = NodeWrapper1.AsNode.PrefHeight
			
			Dim XAdj As Double = (SceneX - ResizeRect.LastSceneX) * NodeWrapper1.ScaleX
			Dim YAdj As Double = (SceneY - ResizeRect.LastSceneY) * NodeWrapper1.ScaleX
			
			
			
			'Limit sizes to MinHeight / MinWidth
			If ResizeRect.ResizeDirection.StartsWith("S") And SceneY < Top + MinHeight Then
				SceneY = Top + MinHeight
				YAdj = SceneY - ResizeRect.LastSceneY
			End If
			
			If ResizeRect.ResizeDirection.StartsWith("N") And SceneY > Top + Height - MinHeight Then
				SceneY = Top + Height - MinHeight
				YAdj = SceneY - ResizeRect.LastSceneY
			End If
			
			If ResizeRect.ResizeDirection.EndsWith("E") And SceneX < Left + MinWidth Then
				SceneX = Left + MinWidth
				XAdj = SceneX - ResizeRect.LastSceneX
			End If
			
			If ResizeRect.ResizeDirection.EndsWith("W") And SceneX > Left + Width - MinWidth Then
				SceneX = Left + Width - MinWidth
				XAdj = SceneX - ResizeRect.LastSceneX
			End If
			
	
			'Do the resize when the mouse cursor is dragged (Moved with a button down)
			Select ResizeRect.ResizeDirection
				Case "N"
					Top = Top + YAdj
					Height = Height - YAdj
				Case "S"
					Height = Height + YAdj
				Case "E"
					Width = Width + XAdj
				Case "W"
					Left = Left + XAdj
					Width = Width - XAdj
				Case "NW"
					'N
					Top = Top + YAdj
					Height = Height - YAdj
'					'W
					Left = Left + XAdj
					Width = Width - XAdj
				Case "NE"
'					'N
					Top = Top + YAdj
					Height = Height - YAdj
'					'E
					Width = Width + XAdj
				Case "SE"
'					'S
					Height = Height + YAdj
'					'E
					Width = Width + XAdj
				Case "SW"
'					'S
					Height = Height + YAdj
'					'W
					Left = Left + XAdj
					Width = Width - XAdj
				Case "M"
					Left = Left + XAdj
					Top = Top + YAdj
			End Select
			
			NodeWrapper1.LayoutX = Left
			NodeWrapper1.LayoutY = Top
			NodeWrapper1.AsNode.PrefWidth = Width
			NodeWrapper1.AsNode.PrefHeight = Height
'			FRSelected.RECT.Set(Array As Double(Left,Top,Width,Height))
			
'			DrawFaces(SortedFaces)
'			SetNW
			ResizeRect.LastSceneY = SceneY
			ResizeRect.LastSceneX = SceneX
		Case "MOUSE_RELEASED"
'			Log("ME")
			NodeWrapper1.ASNode.MouseCursor = fx.Cursors.DEFAULT
	End Select
End Sub

Public Sub ScaleNode(N As Node, Scale As Double)
	Dim ResizeRect As ResizeRectType = ResizeMap.Get(N)
	Dim TargetWidth As Double = (N.PrefWidth / ResizeRect.Scale) * Scale
	Dim TargetHeight As Double = (N.PrefHeight / ResizeRect.Scale) * Scale
	N.Left = N.Left +  N.PrefWidth / 2 - TargetWidth / 2
	N.Top = N.Top + N.PrefHeight / 2 - TargetHeight / 2
	N.PrefWidth = TargetWidth
	N.PrefHeight = TargetHeight
	ResizeRect.Scale = Scale
End Sub